#!/bin/sh

################################################################################
#    Config 1.0. Configuration Server for an Exim Mailsystem                   #
#    Using DB Framwork for PHP  1.1.                                           #
#    Copyright (C) 2006 Luca Bertoncello                                       #
#    Hartigstrasse, 12 - 01127 Dresden Deutschland                             #
#    E-Mail: lucabert@lucabert.de, lucabert@lucabert.com                       #
#    http://www.lucabert.de/  http://www.lucabert.com/                         #
#                                                                              #
#    This program is free software; you can redistribute it and/or modify      #
#    it under the terms of the GNU General Public License as published by      #
#    the Free Software Foundation; version 2 of the License.                   #
#                                                                              #
#    This program is distributed in the hope that it will be useful,           #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#    GNU General Public License for more details.                              #
#                                                                              #
#    You should have received a copy of the GNU General Public License         #
#    along with this program; if not, write to the Free Software               #
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA #
################################################################################

###########################
# Your configuration      #
###########################
DBNAME=<DB name>
DBUSER=<DB user>
DBPWD=<DB password>
YOURDOMAIN=<your domain (eg: mydomain.tld)>
CONFIGURL="URL of your config with ESCAPED '/' (eg: https:\/\/config.mydomain.tld\/)>"
TODELETEDAYS=<Days after them the system deletes the spam E-Mails (eg: 14)>

###########################
# Your paths              #
###########################
CMDAWK=/usr/bin/awk
CMDCAT=/bin/cat
CMDDATE=/bin/date
CMDECHO=/bin/echo
CMDEXPR=/usr/bin/expr
CMDEGREP=/bin/egrep
CMDGREP=/bin/grep
CMDFIND=/usr/bin/find
CMDHEAD=/usr/bin/head
CMDMAIL=/usr/bin/mail
CMDMKTEMP=/bin/mktemp
CMDMYSQL=/usr/bin/mysql
CMDRM=/bin/rm
CMDSED=/bin/sed
CMDTAIL=/usr/bin/tail
CMDWC=/usr/bin/wc

###########################
# Do NOT make any changes #
# after this line!        #
###########################
HEADERMAILFILE=/home/exim/headerEMailLog_$1.txt
SPAMLOGGERLOG=/var/log/spamLogger.log

DATETODAY=`$CMDDATE +%d/%m/%Y`
DATETOLOG=`$CMDDATE +%d/%m/%Y --date '1 day ago'`
DATELOG=`$CMDDATE +%d-%m-%Y --date '1 day ago'`
DELIVERYDATE=`LC_ALL=C $CMDDATE +"Delivery-date: %a, %d %b %Y" --date '1 day ago'`
for USER in `$CMDMYSQL -u $DBUSER --password=$DBPWD $DBNAME --skip-column-names --batch --raw -e "select accountname from account where virtual = 'f' and accountType = 'MBOX' order by accountname;"`; do
  FINALDESTSPAM=`$CMDMYSQL --raw --batch --skip-column-names -u $DBUSER --password=$DBPWD $DBNAME -e "select finaldestSpam from account where accountname = '$USER';" | $CMDGREP -v result`
  ADMINEMAIL=`$CMDMYSQL --raw --batch -u $DBUSER --password=$DBPWD $DBNAME -e "select concat(aliasname, '@', domainname) as result from account join aliases using(accountname) join domain using(domainname) where dataSpam like '%: $USER%' limit 1;" | $CMDGREP -v result`

  TMP=`$CMDMKTEMP`
####  for mail in `$CMDFIND $FINALDESTSPAM | $CMDEGREP '(cur|new)/'`; do
  for mail in `$CMDFIND $FINALDESTSPAM | $CMDEGREP '(new)/'`; do
    $CMDGREP "$DELIVERYDATE" $mail > /dev/null 2>&1
    if [ $? = 0 ]; then
      FROM=`$CMDGREP "^From:" $mail | $CMDAWK -F 'From: ' '{print $2}'`
      SUBJ=`$CMDGREP "^Subject:" $mail | $CMDAWK -F 'Subject: ' '{print $2}'`
      $CMDECHO "Spam message from $FROM (Subj: $SUBJ)" >> $TMP
    fi
  done

  if [ -s $TMP ]; then
    SUBJ=`$CMDHEAD -n 1 $HEADERMAILFILE | $CMDSED -e "s/%%DATELOG%%/$DATELOG/g"`
    LINES=`$CMDWC -l $HEADERMAILFILE | $CMDAWK '{print $1}'`;
    NLINES=`$CMDEXPR $LINES - 1`
    ($CMDTAIL -n $NLINES $HEADERMAILFILE | $CMDSED -e "s/%%LOGINUSER%%/$USER/g" -e "s/%%DOMAIN%%/$YOURDOMAIN/g" -e "s/%%URLCONFIG%%/$CONFIGURL/g" -e "s/%%TODELETEDAY%%/$TODELETEDAYS/g"; $CMDECHO "`$CMDCAT $TMP`")  | $CMDMAIL -s "$SUBJ" $ADMINEMAIL
    $CMDECHO "[$DATETODAY] Sent Spamlog to $ADMINEMAIL" >> $SPAMLOGGERLOG
  fi

  $CMDRM -f $TMP
done
