<?php
/**
 * DB-Class für domain
 */
class Domain extends myMVC_BaseDB
{
  public function __construct()
  {
    parent::__construct('domain',
                        array('domainname'            => 'Domain::checkString255NotNull',
                        ),
                        array('domainname' => 'pk'),
                        array());
    $this->registerFinder('findAll', array(), array());
    $this->registerFinder('findByDomainname', array('domainname' => 'LIKE'), array());
    $this->registerCounter('getCountAll', array(), array());
  }

  /**
   * Gibt alle Domains, für die der Nutzer eine Berechtigung hat
   * 
   * @param string $accountname           Der Nutzer
   * @return array                        Die Domains
   */
  public static function getDomainsForUser($accountname)
  {
    $db = new Domain();
    $ret = array();
    $res = $db->findBySQLQuery(sprintf('SELECT DISTINCT domain.*
                                        FROM domain JOIN aliases USING (domainname)
                                        WHERE aliases.accountname = %s',
                          $db->engine->quoteSqlString($accountname)));
    while($row = $db->engine->getValueArrayFromResult($res))
    {
      $rowClass = new Domain();
      $rowClass->saveValues($row);
      array_push($ret, $rowClass);
    }
    $db->engine->freeResult($res);
    return $ret;
  }
}
?>