<?php
/**
 * Example to use myMVC.
 * This program just demonstrate how to create
 * a login form, authenticate user, check data from
 * a form and read data from database.
 * 
 * Author: Luca Bertoncello <lucabert@lucabert.de>
 */

/**
 * This is the View-Class for the login.
 * It just display the login page.
 */
class LoginView extends myMVC_BaseLoginView
{
  public function __construct($engine, $session)
  {
    parent::__construct($engine, $session);
    $this->setTemplate('login.tpl');
  }

  /**
   * Prepare to render the View
   * 
   * @return boolean                true if the page can be display, false otherwise
   */
  public function preRender()
  {
    $this->engine->registerFunction('getActionGroup', array('GUIView', 'getActionGroup'));
    $this->setVariable('CURRENTVERSION', $this->session->getFromNamespace('main', 'version'));

// The static function myMVC_Controller::getAvailableLanguages() returns the
// defined available languages
    $this->setVariable('availableLanguages', myMVC_Controller::getAvailableLanguages());
// The static function myMVC_Controller::getCurrentLanguage() returns the currently
// choosed language.
// The language's management will be done from the controller!
    $this->setVariable('currentLang', myMVC_Controller::getCurrentLanguage());
// Display all submitted fields (validated and not)
    $this->setAllSubmitFields();
    return true;
  }
}
?>
