<?php
class ManageListView extends GUIView
{
  public function __construct($engine, $session)
  {
    parent::__construct($engine, $session);
    $this->setTemplate('manageList.tpl');
  }

  /**
   * Returns the token used to identify the current View
   * 
   * @return string                 The token
   */
  public static function getViewToken()
  {
    return 'manageList';
  }

  /**
   * Prepare to render the View
   * 
   * @return boolean                true if the page can be display, false otherwise
   */
  public function preRender()
  {
    parent::preRender();

    $user = self::getLoggedUser();
    $this->setVariable('user', $user);
    $this->session->useNamespace('manageList');
    $this->setObject('lists', $this->getParameterFromPreviousPage('lists'));
    $this->setObject('adminUser', $this->getParameterFromPreviousPage('adminUser'));
    $this->setObject('account', $this->getParameterFromPreviousPage('account'));
    $this->setObject('types', Userpref::getPreferenceTypes());
    if($this->getParameterFromPreviousPage('error') === true)
      $this->setAllSubmitFields();

    return true;
  }
}
?>
