<?
/*******************************************************************************
*    Config 1.0. Configuration Server for an Exim Mailsystem                   *
*    Using DB Framwork for PHP  1.1.                                           *
*    Copyright (C) 2006 Luca Bertoncello                                       *
*    Hartigstrasse, 12 - 01127 Dresden Deutschland                             *
*    E-Mail: lucabert@lucabert.de, lucabert@lucabert.com                       *
*    http://www.lucabert.de/  http://www.lucabert.com/                         *
*                                                                              *
*    This program is free software; you can redistribute it and/or modify      *
*    it under the terms of the GNU General Public License as published by      *
*    the Free Software Foundation; version 2 of the License.                   *
*                                                                              *
*    This program is distributed in the hope that it will be useful,           *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of            *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
*    GNU General Public License for more details.                              *
*                                                                              *
*    You should have received a copy of the GNU General Public License         *
*    along with this program; if not, write to the Free Software               *
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
*******************************************************************************/

function __autoload($class)
{
  require_once(dirname(__FILE__).'/../incs/'.$class.'.php');
}

require_once(dirname(__FILE__).'/../3rdpartypacks/myMVC/myMVC.php');
require_once(dirname(__FILE__).'/../etc/etc.php');

$username = $argv[1];
$password = $argv[2];

if($username == '' || $password == '')
  echo "Usage:\ncreateServerAdmin.php <username of the server admin> <password>\n";
else
{
  $err = '';
  $acc = Account::findByPK(array('accountname' => $username));
  if($acc !== NULL)
    $err .= "This username already exists!\n";
  else
  {
    if(rtrim($username) != '' && !isValidAccount($username))
      $err .= "The given username is not valid!\n";
  }
  if($err == '')
  {
    $info = posix_getpwnam($config['MBOXCONFIG']['EXIMUSER']);
    $na = new Account();
    $na->setAccountname($username);
    $na->setPasswd($password);
    $na->setDataHam('save %%FINALDEST%%');
    $na->setDataSpam(sprintf('pipe "/opt/exim/logSpam.sh $header_from: $header_subject: %s"\nsave %%FINALDESTSPAM%%',
        $username));
    $na->setFinaldest($na->getMailbox('mail', ''));
    $na->setFinaldestSpam($na->getMailbox('spam', ''));
    $na->setVirtual('f');
    $na->setIsAdmin('t');
    $na->setCanModifyAlias('t');
    $na->setCanSetAutoresponder('t');
    $na->setCanUseFilters('t');
    $na->setToActivate('t');
    $na->setAccountType('MBOX');
    $na->setFilters(NULL);
    $na->setHasAutoresponder('f');
    $na->setAutoresponderSubject(NULL);
    $na->setAutoresponderText(NULL);
    $na->setUid($info['uid']);
    $na->setSpamScanType('SPAMFOLDER');
    $na->setVirusScanType('REJECT');
    $na->setUseSPF('t');
    $na->setUseGreylist('t');
    $na->setUseDomainKey('f');
    $na->setToDelete('f');
    $na->setRejectedSpamScore(0);
    $na->setRejectAfterSize(NULL);
    $na->save();
    echo "Server administrator [$username] successfully created!\n";
  }
  else
    echo "Error:\n$err";
}

function isValidAccount($accountname)
{
  $regex = '/^[A-z0-9\w\.\-]{4,16}$/';

  return (preg_match($regex, $accountname));
}
?>
